//+------------------------------------------------------------------+
//|                                                  TradeOnNews.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int    Magic          = 111; //   
extern string StartTime      = "15:30";  //     (  MetaTrader)
extern string CloseTime      = "16:00";  //   
extern int    Delta          = 15;  //       
extern int    StopLoss       = 20;
extern int    TakeProfit     = 30;
extern double Lot            = 0.1;

int Ticket, day, EP, Min_Dist;
string Symb, Text;

double   Mas_Ord[31][13];   //  
int      Mas_Tip[6];            //  .    // []  : 0=B,1=S,2=BL,3=SL,4=BS,5=SS
int      Mas_Tip_T[6];          //  .    -  
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   Symb = Symbol();    //  ..
   Min_Dist = MarketInfo(Symb,MODE_STOPLEVEL); //   -/-  
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int total;
   double Price, LT, SL, TP;
   bool answer;
   total = OrdersTotal(); //    
   Orders(); //    
   if(total > 1) //     -    
    {
     for(int i = 0; i < total; i ++) //  
      {
       if(OrderSelect(i, SELECT_BY_POS) == false) continue; //    ,    
       if(Magic != OrderMagicNumber()) continue;//        Magic -    
       Ticket = OrderTicket(); //   
       if(Mas_Tip[0] > 0 && OrderType() == OP_SELLSTOP) //      -    //   
        {
         Text ="SellStop"; //   inf...         .
         inf(5, Ticket, -1); //   ...     SellStop 
         answer = OrderDelete(Ticket); //  
         if(answer == true) //  true    
          { //   
           inf(7, Ticket, -1); //   ...     SellStop  
           return(0); //   start()
          }
         inf(15, GetLastError()); //      ...   
         return(0); //   start()
        }
       if(Mas_Tip[1] > 0 && OrderType() == OP_BUYSTOP) //      -    //   
        {
         Text ="BuyStop"; //   inf...         .
         inf(5, Ticket, -1); //   ...     BuyStop 
         answer = OrderDelete(Ticket); //  
         if(answer == true) //  true    
          { //   
           inf(7, Ticket, -1); //   ...     BuyStop  
           return(0); //   start()
          }
         inf(15, GetLastError()); //      ...   
         return(0); //   start()
        }
      } //  
    }
//-----------------------------------
   if(total == 1 && Mas_Tip[4] == 1) //        
    {
     LT = Lot(); //    
     if(LT == -1) return(0); //  - Lot()  -1        -   start()
     Price = Bid - Delta*Point; //    
     Price = NormalizeDouble(Price, Digits); //        
     SL = Price + StopLoss*Point; //  
     SL = NormalizeDouble(SL, Digits); //        
     TP = Price - TakeProfit*Point; //  
     TP = NormalizeDouble(TP, Digits); //        
     if(((Bid - Price) > Min_Dist*Point) && ((SL - Price) > Min_Dist*Point) && ((Price - TP) > Min_Dist*Point))
      {//  .  -  , -, -
       Expiration(); //   Expiration      
       Text = "SellStop"; //   inf...         .
       inf(1, Ticket, -1); //   ...     SellStop 
       Ticket = OrderSend(Symb,OP_SELLSTOP,LT,Price,3,SL,TP,NULL,Magic,EP,Red); //  
       if(Ticket > 0) //  Ticket  0    ... Ticket   
        { //   
         inf(2, Ticket, -1); //   ...     SellStop  
         return(0); //   start()
        }
       inf(15, GetLastError()); //      ...   
       return(0); //   start()
      }
    }
//-------------------------------
   if((total == 0) && (TimeCurrent() > StrToTime(StartTime)) && (TimeCurrent() < StrToTime(StartTime) + 60))
    { //                      60 
     LT = Lot(); //    
     if(LT == -1) return(0); //  - Lot()  -1        -   start()
     Price = Ask + Delta*Point; //    
     Price = NormalizeDouble(Price, Digits); //        
     SL = Price - StopLoss*Point; //  
     SL = NormalizeDouble(SL, Digits); //        
     TP = Price + TakeProfit*Point; //  
     TP = NormalizeDouble(TP, Digits); //        
     if(((Price - Ask) > Min_Dist*Point) && ((Price - SL) > Min_Dist*Point) && ((TP - Price) > Min_Dist*Point))
      {//  .  -  , -, -
       Expiration(); //   Expiration      
       Text = "BuyStop"; //   inf...         .
       inf(1, Ticket, -1); //   ...     BuyStop 
       Comment("Min_Dist = ",Min_Dist,"\nLT = ",LT);
       Ticket = OrderSend(Symb,OP_BUYSTOP,LT,Price,3,SL,TP,NULL,Magic,EP,Blue); // 
       if(Ticket > 0) //  Ticket  0    ... Ticket   
        { //   
         inf(2, Ticket, -1); //   ...     BuyStop  
         return(0); //   start()
        }
       inf(15, GetLastError()); //      ...   
       return(0); //   start()
      }
    }
   return(0); //   start()
  }
//+------------------------------------------------------------------+
//                                                         |
//+------------------------------------------------------------------+
double Lot()
 {
  int q;
  double dLot, Min_Lot, Max_L, One_Lot;
  One_Lot = MarketInfo(Symb,MODE_MARGINREQUIRED);// . 1 
  Min_Lot = MarketInfo(Symb,MODE_MINLOT);// . . 
  Max_L = MarketInfo(Symb,MODE_MAXLOT);// ax. . 
  dLot = Lot;
//---------
  //    ()
//---------  
  if(Min_Lot == 0.1) q = 1;
  if(Min_Lot == 0.01) q = 2;
  dLot = NormalizeDouble(dLot,q); //        
  if(dLot < Min_Lot) dLot = Min_Lot; //      -   
  if(dLot > Max_L) dLot = Max_L;//      -   
  if(dLot*One_Lot > AccountFreeMargin()) //   ..
   {                         // .. . :(
    inf(12,0,dLot);   // ..
    return(-1);       // .. 
   } // 
  return(dLot); //   
 }
//+------------------------------------------------------------------+
//      - ,   .          |
//+------------------------------------------------------------------+
int Orders()//  ... , ,  ,   .
 {
  int Qnt = 0;                          //   
  Qnt = 0;                              //   
  ArrayInitialize(Mas_Ord,0);       //  
  ArrayInitialize(Mas_Tip,0);           //  
  ArrayInitialize(Mas_Tip_T,0);         //  
  for(int i = 0; i < OrdersTotal(); i++)//  .  . 
   {
    if((OrderSelect(i,SELECT_BY_POS) == true) && (OrderSymbol() == Symb))//  .  //..   .
     {
      if(Magic != OrderMagicNumber()) continue;//        Magic -    
      Qnt++;                                            // .          
      Mas_Ord[Qnt][1] = OrderOpenPrice();           //   
      Mas_Ord[Qnt][2] = OrderStopLoss();            //  SL
      Mas_Ord[Qnt][3] = OrderTakeProfit();          //  
      Mas_Ord[Qnt][4] = OrderTicket();              //  
      Mas_Ord[Qnt][5] = OrderLots();                //  
      Mas_Tip[OrderType()]++;                           // .  
      Mas_Ord[Qnt][6] = OrderType();                //  
      Mas_Ord[Qnt][7] = OrderMagicNumber();         //  
      if(OrderComment() == "") Mas_Ord[Qnt][8] = 0; //   
      else Mas_Ord[Qnt][8] = 1;                     //   
      Mas_Ord[Qnt][9] = OrderOpenTime();            //   
      Mas_Ord[Qnt][10] = OrderCloseTime();          //   
      Mas_Ord[Qnt][11] = OrderExpiration();     //       .
      if(day == TimeDayOfYear(OrderOpenTime()))         //    ...
       {
        Mas_Tip_T[OrderType()]++;                       // .  ...  
       }
     }
   }
  Mas_Ord[0][0] = Qnt;                         // . 
  return;
 }
//+------------------------------------------------------------------+
//                                                                   |
//+------------------------------------------------------------------+
int Expiration()
 { //        -     (60*60*24)
  if(StrToTime(StartTime) > StrToTime(CloseTime)) EP = 60*60*24 + StrToTime(CloseTime);
    else EP = StrToTime(CloseTime); //         -  
 }
//----------------------------------------------------------------+
//
//----------------------------------------------------------------+
int inf(int Mess_Number, int Number=0, double Value=0.0)
 {
  string Graf_Text;                   //  
  switch(Mess_Number)                 //   
   {  
    case 1:  Graf_Text = StringConcatenate("  ",Text," .  ..");  break;
    case 2:  Graf_Text = StringConcatenate(" ",Text," :  ",Number);           break;
    case 3:  Graf_Text = StringConcatenate("  ",Text," :  ",Number,".  .."); break;
    case 4:  Graf_Text = StringConcatenate(" ",Text,"  :  ",Number);   break;
    case 5:  Graf_Text = StringConcatenate("  ",Text,"   ",Number,".  ..");  break;
    case 6:  Graf_Text = StringConcatenate(" ",Text," :  ",Number);           break;
    case 7:  Graf_Text = StringConcatenate("  ",Text,"   ",Number); break;
    case 8:  Graf_Text = StringConcatenate(" ",Number,"   "); break;
    case 9:  Graf_Text = StringConcatenate("  ",Number);                   break;
    case 10: Graf_Text = StringConcatenate("   ",Number);              break;
    case 11: Graf_Text = StringConcatenate("  : ",Number);       break;
    case 12: Graf_Text = StringConcatenate("    ",DoubleToStr(Value,2)," "); break;
    case 15: switch(Number)                 //    
              {
               case 2: Graf_Text = " .";
                       break;
               case 4: Graf_Text = "  .";
                       if(IsTesting() == false) Sleep(5000); //     - ""  5 .
                       break;
               case 129: Graf_Text = " .";
                         break;
               case 130: Graf_Text = " .";
                         break;
               case 135: Graf_Text = " .";
                         break;
               case 136: Graf_Text = " .   ..";
                         if(IsTesting() == false) Sleep(1); //     - ""  1 .
                         break;
               case 137: Graf_Text = " .";
                         if(IsTesting() == false)Sleep(5000); //     - ""  5 .
                         break;
               case 146: Graf_Text = "  .";
                         if(IsTesting() == false) Sleep(500); //     - ""   .
                         break;
               case 5 :  Graf_Text = "  .";
                         break;
               case 64:  Graf_Text = " .";
                         break;
               case 133: Graf_Text = " ";
                         break;
               case 134: Alert("    .");
                         return(0);                             //   
               default:  Graf_Text = StringConcatenate("  ",Number);
              }
             break;
    default: Graf_Text = StringConcatenate("default ",Mess_Number);
   }
  Alert(Graf_Text);
 }
//+------------------------------------------------------------------+